## flightgear 2018.3.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)

include (CheckFunctionExists)
include (CheckVariableExists)
include (CheckCSourceCompiles)
include (CheckCXXSourceCompiles)
include (CheckIncludeFile)

if(COMMAND cmake_policy)
   if(POLICY CMP0054)
       cmake_policy(SET CMP0054 NEW)
   endif()
   # Mac RPATH policy
   if(POLICY CMP0042)
       cmake_policy(SET CMP0042 NEW)
   endif()

    # AUTOMOC/AUTOUIC on generated files policy. Since we only
    # generate resource files with fgrcc which don't use Qt,
    # we set those files source property. See the help for this
    # policy for more info
    if(POLICY CMP0071)
        cmake_policy(SET CMP0071 NEW)
    endif()
endif()

message("CMAKE Build type: ${CMAKE_BUILD_TYPE}")
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

if(NOT FG_BUILD_TYPE)
  message(STATUS "Setting build type to 'Dev' as none was specified.")
  set(FG_BUILD_TYPE Dev CACHE STRING "Choose the FlightGear build type" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE FG_BUILD_TYPE PROPERTY STRINGS "Dev" "Nightly" "Release")
endif()

if(APPLE)
	set(CMAKE_INSTALL_RPATH "@loader_path/../Frameworks")
	# when building, don't use the install RPATH already
	# (but later on when installing)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
endif()

# let's use & require C++11 - note these are only functional with CMake 3.1
# we do manual fallbacks for CMake 3.0 in the compilers section
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED YES)

set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

project(FlightGear)

# We have some custom .cmake scripts not in the official distribution.
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")
set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

# Warning when build is not an out-of-source build.
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" InSourceBuild)
if(InSourceBuild)
    message(WARNING  "Avoid building inside the source tree!")
    message(WARNING  "Create a separate build directory instead (i.e. 'fgbuild') and call CMake from there: ")
    message(WARNING  "  mkdir ../fgbuild && cd ../fgbuild && cmake ${CMAKE_SOURCE_DIR}")
endif(InSourceBuild)

include(GNUInstallDirs)
# System detection/default settings
include( DetectDistro )
include( DetectBrowser )

set(CMAKE_DEBUG_POSTFIX          "d" CACHE STRING "add a postfix, usually d on windows")
set(CMAKE_RELEASE_POSTFIX        ""  CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_RELWITHDEBINFO_POSTFIX ""  CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_MINSIZEREL_POSTFIX     ""  CACHE STRING "add a postfix, usually empty on windows")

# read 'version' file into a variable (stripping any newlines or spaces)
file(READ version versionFile)
if (NOT versionFile)
    message(FATAL_ERROR "Unable to determine FlightGear version. Version file is missing.")
endif()
string(STRIP "${versionFile}" FLIGHTGEAR_VERSION)
# add a dependency on the version file
set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS version)

# FlightGear packaging (to build a source tarball)
include( ConfigureCPack )

# FlightGear base package path
if (FG_DATA_DIR)
    message(STATUS "Using explicit data directory for base package: ${FG_DATA_DIR}")
else()
    set(FG_DATA_DIR "${CMAKE_INSTALL_PREFIX}/lib/FlightGear" CACHE PATH "Default location where data files are located")
    message(STATUS "Using default data directory for base package:  ${FG_DATA_DIR}")
endif()

# Change the default build type to something fast
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif(NOT CMAKE_BUILD_TYPE)

#####################################################################################
# Configure library search paths
#####################################################################################

IF(APPLE)
    set(EVENT_INPUT_DEFAULT 1)

    find_library(CORESERVICES_LIBRARY CoreServices)
    find_library(COCOA_LIBRARY Cocoa)
    list(APPEND PLATFORM_LIBS ${COCOA_LIBRARY} ${CORESERVICES_LIBRARY})
elseif(WIN32)
    list(APPEND PLATFORM_LIBS "Shlwapi.lib")

    set(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION "bin")
    set(CMAKE_INSTALL_UCRT_LIBRARIES TRUE)
    include(InstallRequiredSystemLibraries)
    MESSAGE("Installing: ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS}")

elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR
	${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    find_package(Threads REQUIRED)
    find_package(X11 REQUIRED)

    set(USE_DBUS_DEFAULT 1)

    find_package(UDev)
    if(UDEV_FOUND)
        set(EVENT_INPUT_DEFAULT 1)
    endif(UDEV_FOUND)

    find_package(Speex)
    find_package(Speexdsp)
    if(SPEEX_FOUND AND SPEEXDSP_FOUND)
        set(SYSTEM_SPEEX_DEFAULT 1)
    endif(SPEEX_FOUND AND SPEEXDSP_FOUND)

    find_package(Gsm)
    if(GSM_FOUND)
        set(SYSTEM_GSM_DEFAULT 1)
    endif(GSM_FOUND)

    find_package(Flite)
    if(FLITE_FOUND)
        set(SYSTEM_FLITE_DEFAULT 1)
    endif()

    find_package(HtsEngine)
    if(HTS_ENGINE_FOUND)
        set(SYSTEM_HTS_ENGINE_DEFAULT 1)
    endif()

    find_package(CppUnit)
    if (CPPUNIT_FOUND)
        set(SYSTEM_CPPUNIT_DEFAULT 1)
    endif()
endif()

# FlightGear build options
option(LOGGING           "Set to ON to build FlightGear with logging support (default)" ON)
option(JSBSIM_TERRAIN    "Set to ON to build FlightGear with JSBSim terrain handling code" ON)
option(SP_FDMS           "Set to ON to build FlightGear with special-purpose FDMs" ON)
option(ENABLE_UIUC_MODEL "Set to ON to build FlightGear with UIUCModel FDM" ON)
option(ENABLE_LARCSIM    "Set to ON to build FlightGear with LaRCsim FDM" ON)
option(ENABLE_YASIM      "Set to ON to build FlightGear with YASIM FDM (default)" ON)
option(ENABLE_JSBSIM     "Set to ON to build FlightGear with JSBSim FDM (default)" ON)
option(EVENT_INPUT       "Set to ON to build FlightGear with event-based Input support" ${EVENT_INPUT_DEFAULT})
option(ENABLE_RTI        "Set to ON to build FlightGear with RTI support" OFF)
option(ENABLE_PROFILE    "Set to ON to build FlightGear with gperftools profiling support" OFF)
option(SYSTEM_SQLITE     "Set to ON to build FlightGear with the system's SQLite3 library" OFF)
option(ENABLE_IAX        "Set to ON to build FlightGear with IAXClient/fgcom built-in (default)" ON)
option(USE_DBUS          "Set to ON to build FlightGear with DBus screensaver interaction (default on Linux)" ${USE_DBUS_DEFAULT})
option(SYSTEM_SPEEX      "Set to ON to build IAXClient with the system's speex and speexdsp library" ${SYSTEM_SPEEX_DEFAULT})
option(SYSTEM_GSM        "Set to ON to build IAXClient with the system's GSM library" ${SYSTEM_GSM_DEFAULT})
option(SYSTEM_FLITE      "Set to ON to build Flightgear with the system's Flite library" ${SYSTEM_FLITE_DEFAULT})
option(SYSTEM_HTS_ENGINE "Set to ON to build Flightgear with the system's HTS Engine library" ${SYSTEM_HTS_ENGINE_DEFAULT})
option(SYSTEM_CPPUNIT    "Set to ON to build Flightgear with the system's CppUnit library" ${SYSTEM_CPPUNIT_DEFAULT})

# additional utilities
option(ENABLE_FGELEV     "Set to ON to build the fgelev application (default)" ON)
option(WITH_FGPANEL      "Set to ON to build the fgpanel application (default)" ON)
option(ENABLE_FGVIEWER   "Set to ON to build the fgviewer application (default)" ON)
option(ENABLE_GPSSMOOTH  "Set to ON to build the GPSsmooth application (default)" ON)
option(ENABLE_TERRASYNC  "Set to ON to build the terrasync application (default)" ON)
option(ENABLE_FGJS       "Set to ON to build the fgjs application (default)" ON)
option(ENABLE_JS_DEMO    "Set to ON to build the js_demo application (default)" ON)
option(ENABLE_METAR      "Set to ON to build the metar application (default)" ON)
option(ENABLE_STGMERGE   "Set to ON to build the stgmerge application (default)" OFF)
option(ENABLE_FGCOM      "Set to ON to build the FGCom application (default)" ON)
option(ENABLE_FLITE      "Set to ON to build the Flite text-to-speech module" ON)
option(ENABLE_QT         "Set to ON to build the internal Qt launcher" ON)
option(ENABLE_TRAFFIC    "Set to ON to build the external traffic generator modules" ON)
option(ENABLE_FGQCANVAS  "Set to ON to build the Qt-based remote canvas application" OFF)
option(ENABLE_DEMCONVERT "Set to ON to build the dem conversion tool (default)" ON)
option(ENABLE_HID_INPUT  "Set to ON to build HID-based input code" OFF)
option(ENABLE_PLIB_JOYSTICK  "Set to ON to enable legacy joystick code (default)" ON)



# Test-suite options.
option(ENABLE_AUTOTESTING "Set to ON to execute the test suite after building the test_suite target (default)" ON)

include (DetectArch)

# when building an OSG with commit 15ec7e2ae7a8b983ecc44e1ce7363a9a9fa7da95
# applied, we can use better link options
option(OSG_FSTREAM_EXPORT_FIXED "Set to ON if the osgDB fstream export patch is applied" OFF)

if(LOGGING)
    # nothing
else()
    set(FG_NDEBUG 1)
endif()

if(JSBSIM_TERRAIN)
   set(JSBSIM_USE_GROUNDREACTIONS 1)
endif()

if(SP_FDMS)
    set(ENABLE_SP_FDM 1)
endif()

if(ENABLE_FGCOM)
  set(ENABLE_IAX 1)
  include_directories(${PROJECT_SOURCE_DIR}/3rdparty/iaxclient/lib ) # for iaxclient.h
endif()

# Setup MSVC 3rd party directories
include( ConfigureMsvc3rdParty )

if(EVENT_INPUT)
    if(APPLE)
      add_definitions(-DWITH_EVENTINPUT)
      find_library(IOKIT_FRAMEWORK IOKit)
      list(APPEND EVENT_INPUT_LIBRARIES ${IOKIT_FRAMEWORK})
    elseif(CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD")
        if(NOT UDEV_FOUND)
            message(WARNING "UDev not found, event input is disabled!")
            set(EVENT_INPUT 0)

            # HIDraw backend for hidapi also needs UDev, so also force
            # HID-input to off in this scenario
            set(ENABLE_HID_INPUT 0)
        else()
            add_definitions(-DWITH_EVENTINPUT)
            set(EVENT_INPUT_LIBRARIES ${UDEV_LIBRARIES})
            message(STATUS "event-based input enabled. Using ${UDEV_LIBRARIES}")
        endif()
    else()
        message(WARNING "event-based input is not supported on this platform yet")
    endif()

    if (ENABLE_HID_INPUT)
        message(STATUS "Enabling HID-API input")
        list(APPEND EVENT_INPUT_LIBRARIES hidapi)
    endif()
endif(EVENT_INPUT)

# check required dependencies
find_package(Boost REQUIRED)
find_package(OpenGL  REQUIRED)
find_package(OpenSceneGraph 3.2.0 REQUIRED
  osgText
  osgSim
  osgDB
  osgParticle
  osgFX
  osgUtil
  osgViewer
  osgGA
)

if (MSVC)
	find_package(CrashRpt)
	if (CRASHRPT_FOUND)
		set(HAVE_CRASHRPT 1)
		message(STATUS "Using CrashRpt")
    include_directories( ${CRASHRPT_INCLUDE_DIR})
	endif()
endif()

##############################################################################
## Sqlite3 setup

if (SYSTEM_SQLITE)
    find_package(SQLite3 REQUIRED)
    message(STATUS "Using system SQLite3 library")
else()
    set(SQLITE3_INCLUDED_DIR "${CMAKE_SOURCE_DIR}/3rdparty/sqlite3")
    # this target is defined in src/Navaids/CMakeLists.txt
    list(APPEND SQLITE3_LIBRARY fgsqlite3)
endif (SYSTEM_SQLITE)

# Sqlite always depends on the threading lib
list(APPEND SQLITE3_LIBRARY ${CMAKE_THREAD_LIBS_INIT})

##############################################################################
## DBus setup

if (USE_DBUS)
    include(FindPkgConfig)
    if (PKG_CONFIG_FOUND)
        pkg_check_modules(DBUS dbus-1)

=== 3rdparty/CMakeLists.txt ===

if (NOT SYSTEM_SQLITE)
    add_subdirectory(sqlite3)
endif()

if (ENABLE_IAX)
    add_subdirectory(iaxclient/lib)
endif()

add_subdirectory(mongoose)
add_subdirectory(cjson)

if (ENABLE_FLITE)
    add_subdirectory(flite_hts_engine)

    if (SYSTEM_HTS_ENGINE)
        set(HTS_Engine_FIND_REQUIRED TRUE)
        find_package(HtsEngine)

        include_directories(${HTS_ENGINE_INCLUDE_DIR})
        message(STATUS "Using HTS engine includes at: ${HTS_ENGINE_INCLUDE_DIR}")
        message(STATUS "Using HTS engine libraries: ${HTS_ENGINE_LIBRARIES}")
    else()
        add_subdirectory(hts_engine_API)
        include_directories(${PROJECT_SOURCE_DIR}/3rdparty/hts_engine_API/include )
    endif()
endif()

if (ENABLE_HID_INPUT)
    add_subdirectory(hidapi)
endif()

if (ENABLE_PLIB_JOYSTICK)
    add_subdirectory(joystick)
endif()

if (NOT SYSTEM_CPPUNIT)
    add_subdirectory(cppunit)
endif()

=== test_suite/CMakeLists.txt ===
# CMake module includes.
include(SetupFGFSEmbeddedResources)
include(SetupFGFSIncludes)
include(SetupFGFSLibraries)
include(SetupMSVCGrouping)

# Add each test suite category.
foreach(test_category
        gui_tests
        simgear_tests
        system_tests
        unit_tests
    )
    add_subdirectory(${test_category})
endforeach(test_category)

# Add the testing API.
add_subdirectory(FGTestApi)

# Add all test suite sources and headers.
set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    bootstrap.cxx
    dataStore.cxx
    fgCompilerOutputter.cxx
    fgTestListener.cxx
    fgTestRunner.cxx
    formatting.cxx
    logging.cxx
    testSuite.cxx
)
set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    dataStore.hxx
    fgCompilerOutputter.hxx
    fgTestListener.hxx
    fgTestRunner.hxx
    formatting.hxx
    logging.hxx
)

# The test suite output directory.
set(TESTSUITE_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}")

# Get the CppUnit sources and headers to be built into the test suite.
if (NOT SYSTEM_CPPUNIT)
    message(STATUS "CppUnit: Building the FlightGear supplied CppUnit library")

    get_property(CPPUNIT_SOURCES GLOBAL PROPERTY CPPUNIT_SOURCES)
    get_property(CPPUNIT_HEADERS GLOBAL PROPERTY CPPUNIT_HEADERS)

    include_directories("${PROJECT_SOURCE_DIR}/3rdparty/cppunit/include")

    add_library(CppUnitLib STATIC ${CPPUNIT_SOURCES} ${CPPUNIT_HEADERS})
    set(CPPUNIT_LIBRARIES CppUnitLib)
else()
    message(STATUS "CppUnit: Linking to the system supplied CppUnit library")
endif()

#-----------------------------------------------------------------------------
# Set up all test suites as CTests.

# Activation.
include(Dart)

# System test suites.
add_test(AeroMeshSystemTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -s AeroMeshTests)
#add_test(GPSSystemTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -s GPSTests)
#add_test(NavaidsSystemTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -s NavaidsTests)

# Unit test suites.
add_test(AddonManagementUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u AddonManagementTests)
add_test(AeroElementUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u AeroElementTests)
add_test(AutosaveMigrationUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u AutosaveMigrationTests)
add_test(FlightplanUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u FlightplanTests)
if(ENABLE_HID_INPUT)
    add_test(HIDInputUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u HIDInputTests)
endif()
add_test(LaRCSimMatrixUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u LaRCSimMatrixTests)
add_test(MktimeUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u MktimeTests)
add_test(NasalSysUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u NasalSysTests)
add_test(NavaidsUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u NavaidsTests)
add_test(PosInitUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u PosInitTests)
add_test(YASimAtmosphereUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -u YASimAtmosphereTests)

# GUI test suites.

# Simgear unit test suites.
add_test(MathGeodesySimgearUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -m MathGeodesyTests)
add_test(SimgearPropsSimgearUnitTests ${TESTSUITE_OUTPUT_DIR}/run_test_suite --ctest -m SimgearPropsTests)

#-----------------------------------------------------------------------------
# Set up the binary.

# Set up the embedded resources.
setup_fgfs_embedded_resources()

# Sort the sources and headers for MSVC.
setup_msvc_grouping()

# Additional search paths for includes.
setup_fgfs_includes()

# All sources and headers to be built into the test suite.
get_property(FG_SOURCES GLOBAL PROPERTY FG_SOURCES)
get_property(FG_HEADERS GLOBAL PROPERTY FG_HEADERS)
get_property(EMBEDDED_RESOURCE_SOURCES GLOBAL PROPERTY EMBEDDED_RESOURCE_SOURCES)
get_property(EMBEDDED_RESOURCE_HEADERS GLOBAL PROPERTY EMBEDDED_RESOURCE_HEADERS)

# Set up the separate executable for running the test suite.
add_executable(run_test_suite
    ${FG_SOURCES}
    ${FG_HEADERS}
    ${EMBEDDED_RESOURCE_SOURCES}
    ${EMBEDDED_RESOURCE_HEADERS}
    ${TESTSUITE_SOURCES}
    ${TESTSUITE_HEADERS}
)
set_target_properties(run_test_suite
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${TESTSUITE_OUTPUT_DIR}"
)
if(ENABLE_AUTOTESTING)
    set(TEST_SUITE_COMMENT "Running the full FlightGear test suite.")
    if(WIN32)
        set(TEST_SUITE_COMMAND "run_test_suite.exe")
        set(TEST_SUITE_WORKING_DIRECTORY "${TESTSUITE_OUTPUT_DIR}/${CMAKE_BUILD_TYPE}")
    else()
        set(TEST_SUITE_COMMAND "run_test_suite")
        set(TEST_SUITE_WORKING_DIRECTORY "${TESTSUITE_OUTPUT_DIR}")
    endif(WIN32)
else()
    set(TEST_SUITE_COMMENT "Building the FlightGear test suite.")
endif(ENABLE_AUTOTESTING)

add_custom_target(test_suite
    ${TEST_SUITE_COMMAND}
    DEPENDS run_test_suite
    WORKING_DIRECTORY ${TEST_SUITE_WORKING_DIRECTORY}
    COMMENT ${TEST_SUITE_COMMENT}
)

# Set up the target links.
setup_fgfs_libraries(run_test_suite)

# Additional libraries just for the test suite.
target_link_libraries(run_test_suite ${CPPUNIT_LIBRARIES})

=== src/EmbeddedResources/CMakeLists.txt ===
add_executable(fgrcc fgrcc.cxx fgrcc.hxx)
target_link_libraries(fgrcc SimGearCore ${PLATFORM_LIBS})

=== src/Input/CMakeLists.txt ===
include(FlightGearComponent)

IF(APPLE)
	set(EVENT_INPUT_SOURCES FGMacOSXEventInput.cxx)
	set(EVENT_INPUT_HEADERS FGMacOSXEventInput.hxx)
elseif(MSVC)
	message(STATUS "EventInput not implemented for Windows yet")
else()
	set(EVENT_INPUT_SOURCES FGLinuxEventInput.cxx)
	set(EVENT_INPUT_HEADERS FGLinuxEventInput.hxx)
endif()

if (ENABLE_HID_INPUT)
	list(APPEND EVENT_INPUT_SOURCES FGHIDEventInput.cxx)
	list(APPEND EVENT_INPUT_HEADERS FGHIDEventInput.hxx)	
endif()

set(SOURCES
	FGButton.cxx
	FGCommonInput.cxx
	FGDeviceConfigurationMap.cxx
	FGEventInput.cxx
	FGKeyboardInput.cxx
	FGMouseInput.cxx
	input.cxx
	)

set(HEADERS
	FGButton.hxx
	FGCommonInput.hxx
	FGDeviceConfigurationMap.hxx
	FGEventInput.hxx
	FGKeyboardInput.hxx
	FGMouseInput.hxx
	input.hxx
	)

if (ENABLE_PLIB_JOYSTICK)
	list(APPEND SOURCES FGJoystickInput.cxx)
	list(APPEND HEADERS FGJoystickInput.hxx)
endif()

if(EVENT_INPUT)
	list(APPEND SOURCES ${EVENT_INPUT_SOURCES})
	list(APPEND HEADERS ${EVENT_INPUT_HEADERS})
	include_directories(${UDEV_INCLUDE_DIR})
endif()

if(ENABLE_FGJS AND ENABLE_PLIB_JOYSTICK)
    set(FGJS_SOURCES
        fgjs.cxx
        jsinput.cxx
        jssuper.cxx
    )

    add_executable(fgjs ${FGJS_SOURCES})
    target_link_libraries(fgjs
		SimGearCore
		PLIBJoystick
    )

    install(TARGETS fgjs RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if(ENABLE_JS_DEMO AND ENABLE_PLIB_JOYSTICK)
    add_executable(js_demo js_demo.cxx)
    target_link_libraries(js_demo
        SimGearCore
        PLIBJoystick
    )

    install(TARGETS js_demo RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if (ENABLE_HID_INPUT)
	if (COMMAND flightgear_test)
		set(HID_INPUT_TEST_SOURCES test_hidinput.cxx FGEventInput.cxx 
			FGCommonInput.cxx FGDeviceConfigurationMap.cxx)

		flightgear_test(hidinput "${HID_INPUT_TEST_SOURCES}")
		target_link_libraries(hidinput ${EVENT_INPUT_LIBRARIES} hidapi)	
	endif()
endif()

flightgear_component(Input "${SOURCES}" "${HEADERS}")

=== test_suite/simgear_tests/CMakeLists.txt ===
# Add each simgear test category.
foreach( simgear_test_category
        math
        props
    )

    add_subdirectory(${simgear_test_category})

endforeach( simgear_test_category )


set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    PARENT_SCOPE
)


set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    PARENT_SCOPE
)

=== test_suite/unit_tests/CMakeLists.txt ===
# Add each unit test category.
foreach( unit_test_category
        Add-ons
        general
        FDM
        Input
        Main
        Navaids
        Scripting
    )

    add_subdirectory(${unit_test_category})

endforeach( unit_test_category )


set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    PARENT_SCOPE
)


set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    PARENT_SCOPE
)

=== utils/fgqcanvas/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED YES)

  # AUTOMOC/AUTOUIC on generated files policy.
  if(POLICY CMP0071)
      cmake_policy(SET CMP0071 NEW)
  endif()

include(GNUInstallDirs)

project(FGQCanvas)

find_package(Qt5 5.4 COMPONENTS Widgets WebSockets Gui Quick)

if (NOT Qt5WebSockets_FOUND OR NOT Qt5Quick_FOUND)
  message(WARNING "FGQCanvas utility requested, but QtWebSockets not found")
  message(STATUS "Check you have the development package for Qt5 WebSockets installed")
  return()
endif()

set(SOURCES
  main.cpp
  localprop.cpp
  localprop.h
  fgcanvaselement.cpp
  fgcanvaselement.h
  fgcanvasgroup.cpp
  fgcanvasgroup.h
  fgcanvaspaintcontext.cpp
  fgcanvaspaintcontext.h
  fgcanvaspath.cpp
  fgcanvaspath.h
  fgcanvastext.cpp
  fgcanvastext.h
  fgqcanvasimage.cpp
  fgqcanvasimage.h
  fgqcanvasmap.cpp
  fgqcanvasmap.h
  canvastreemodel.cpp
  canvastreemodel.h
  fgqcanvasfontcache.cpp
  fgqcanvasfontcache.h
  fgqcanvasimageloader.cpp
  fgqcanvasimageloader.h
  elementdatamodel.cpp
  elementdatamodel.h
  canvasitem.cpp
  canvasitem.h
  canvasconnection.cpp
  canvasconnection.h
  applicationcontroller.cpp
  applicationcontroller.h
  canvasdisplay.cpp
  canvasdisplay.h
  canvaspainteddisplay.cpp
  canvaspainteddisplay.h
  jsonutils.cpp
  jsonutils.h
)

qt5_add_resources(qrc_sources fgqcanvas_resources.qrc)

#qt5_wrap_ui(uic_sources temporarywidget.ui)

add_executable(fgqcanvas ${SOURCES} ${qrc_sources})

set_property(TARGET fgqcanvas PROPERTY AUTOMOC ON)
target_link_libraries(fgqcanvas Qt5::Core Qt5::Widgets Qt5::WebSockets Qt5::Quick)

target_include_directories(fgqcanvas PRIVATE ${PROJECT_SOURCE_DIR})

# so ui_foo.h files are found
target_include_directories(fgqcanvas PRIVATE ${PROJECT_BINARY_DIR})

target_include_directories(fgqcanvas PRIVATE ${Qt5Gui_PRIVATE_INCLUDE_DIRS})
target_include_directories(fgqcanvas PRIVATE ${Qt5Quick_PRIVATE_INCLUDE_DIRS})

install(TARGETS fgqcanvas RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== 3rdparty/cppunit/src/CMakeLists.txt ===
add_subdirectory(cppunit)

set(CPPUNIT_SOURCES
    ${CPPUNIT_SOURCES}
    PARENT_SCOPE
)

=== src/FDM/JSBSim/CMakeLists.txt ===
include(FlightGearComponent)

set(HEADERS
    FGFDMExec.h
    FGJSBBase.h
    JSBSim.hxx
    initialization/FGInitialCondition.h
    initialization/FGTrim.h
    initialization/FGTrimAxis.h
    input_output/FGXMLParse.h
    input_output/FGXMLFileRead.h
    input_output/FGPropertyReader.h
    input_output/FGPropertyManager.h
    input_output/FGScript.h
    input_output/FGfdmSocket.h
    input_output/string_utilities.h
    input_output/FGXMLElement.h
    input_output/net_fdm.hxx
    input_output/FGGroundCallback.h
    input_output/FGInputType.h
    input_output/FGInputSocket.h
    input_output/FGUDPInputSocket.h
    input_output/FGOutputFG.h
    input_output/FGOutputFile.h
    input_output/FGOutputSocket.h
    input_output/FGOutputTextFile.h
    input_output/FGOutputType.h
    input_output/FGModelLoader.h
    math/FGParameter.h
    math/LagrangeMultiplier.h
    math/FGColumnVector3.h
    math/FGCondition.h
    math/FGFunction.h
    math/FGLocation.h
    math/FGMatrix33.h
    math/FGModelFunctions.h
    math/FGPropertyValue.h
    math/FGQuaternion.h
    math/FGRealValue.h
    math/FGRungeKutta.h
    math/FGTable.h
    math/FGFunctionValue.h
    math/FGTemplateFunc.h
    models/FGAccelerations.h
    models/FGAerodynamics.h
    models/FGAircraft.h
    models/FGAtmosphere.h
    models/FGAuxiliary.h
    models/FGBuoyantForces.h
    models/FGExternalForce.h
    models/FGExternalReactions.h
    models/FGFCS.h
    models/FGGasCell.h
    models/FGSurface.h
    models/FGGroundReactions.h
    models/FGInertial.h
    models/FGInput.h
    models/FGLGear.h
    models/FGMassBalance.h
    models/FGModel.h
    models/FGOutput.h
    models/FGPropagate.h
    models/FGPropulsion.h
    models/atmosphere/FGMSIS.h
    models/atmosphere/FGStandardAtmosphere.h
    models/atmosphere/FGMars.h
    models/atmosphere/FGWinds.h
    models/flight_control/FGAccelerometer.h
    models/flight_control/FGActuator.h
    models/flight_control/FGAngles.h
    models/flight_control/FGDeadBand.h
    models/flight_control/FGFCSComponent.h
    models/flight_control/FGFCSFunction.h
    models/flight_control/FGFilter.h
    models/flight_control/FGGain.h
    models/flight_control/FGGyro.h
    models/flight_control/FGKinemat.h
    models/flight_control/FGMagnetometer.h
    models/flight_control/FGPID.h
    models/flight_control/FGSensor.h
    models/flight_control/FGSensorOrientation.h
    models/flight_control/FGSummer.h
    models/flight_control/FGSwitch.h
    models/flight_control/FGWaypoint.h
    models/flight_control/FGDistributor.h
    models/propulsion/FGElectric.h
    models/propulsion/FGEngine.h
    models/propulsion/FGForce.h
    models/propulsion/FGNozzle.h
    models/propulsion/FGPiston.h
    models/propulsion/FGPropeller.h
    models/propulsion/FGRocket.h
    models/propulsion/FGRotor.h
    models/propulsion/FGTank.h
    models/propulsion/FGThruster.h
    models/propulsion/FGTransmission.h
    models/propulsion/FGTurbine.h
    models/propulsion/FGTurboProp.h
    )

set(SOURCES
    FGFDMExec.cpp
    FGJSBBase.cpp
    JSBSim.cxx
    initialization/FGInitialCondition.cpp
    initialization/FGTrim.cpp
    initialization/FGTrimAxis.cpp
    input_output/FGGroundCallback.cpp
    input_output/FGPropertyReader.cpp
    input_output/FGPropertyManager.cpp
    input_output/FGScript.cpp
    input_output/FGXMLElement.cpp
    input_output/FGXMLParse.cpp
    input_output/FGfdmSocket.cpp
    input_output/FGInputType.cpp
    input_output/FGInputSocket.cpp
    input_output/FGUDPInputSocket.cpp
    input_output/FGOutputFG.cpp
    input_output/FGOutputFile.cpp
    input_output/FGOutputSocket.cpp
    input_output/FGOutputTextFile.cpp
    input_output/FGOutputType.cpp
    input_output/FGModelLoader.cpp
    math/FGColumnVector3.cpp
    math/FGCondition.cpp
    math/FGFunction.cpp
    math/FGLocation.cpp
    math/FGMatrix33.cpp
    math/FGModelFunctions.cpp
    math/FGPropertyValue.cpp
    math/FGQuaternion.cpp
    math/FGRealValue.cpp
    math/FGRungeKutta.cpp
    math/FGTable.cpp
    models/FGAccelerations.cpp
    models/FGAerodynamics.cpp
    models/FGAircraft.cpp
    models/FGAtmosphere.cpp
    models/FGAuxiliary.cpp
    models/FGBuoyantForces.cpp
    models/FGExternalForce.cpp
    models/FGExternalReactions.cpp
    models/FGFCS.cpp
    models/FGGasCell.cpp
    models/FGSurface.cpp
    models/FGGroundReactions.cpp
    models/FGInertial.cpp
    models/FGInput.cpp
    models/FGLGear.cpp
    models/FGMassBalance.cpp
    models/FGModel.cpp
    models/FGOutput.cpp
    models/FGPropagate.cpp
    models/FGPropulsion.cpp
    models/atmosphere/FGMSIS.cpp
    models/atmosphere/FGMSISData.cpp
    models/atmosphere/FGStandardAtmosphere.cpp
    models/atmosphere/FGMars.cpp
    models/atmosphere/FGWinds.cpp
    models/flight_control/FGAccelerometer.cpp
    models/flight_control/FGActuator.cpp
    models/flight_control/FGAngles.cpp
    models/flight_control/FGDeadBand.cpp
    models/flight_control/FGFCSComponent.cpp
    models/flight_control/FGFCSFunction.cpp
    models/flight_control/FGFilter.cpp
    models/flight_control/FGGain.cpp
    models/flight_control/FGGyro.cpp
    models/flight_control/FGKinemat.cpp
    models/flight_control/FGMagnetometer.cpp
    models/flight_control/FGPID.cpp
    models/flight_control/FGSensor.cpp
    models/flight_control/FGSummer.cpp
    models/flight_control/FGSwitch.cpp
    models/flight_control/FGWaypoint.cpp
    models/flight_control/FGDistributor.cpp
    models/propulsion/FGElectric.cpp
    models/propulsion/FGEngine.cpp
    models/propulsion/FGForce.cpp
    models/propulsion/FGNozzle.cpp
    models/propulsion/FGPiston.cpp
    models/propulsion/FGPropeller.cpp
    models/propulsion/FGRocket.cpp
    models/propulsion/FGRotor.cpp
    models/propulsion/FGTank.cpp
    models/propulsion/FGThruster.cpp
    models/propulsion/FGTransmission.cpp
    models/propulsion/FGTurbine.cpp
    models/propulsion/FGTurboProp.cpp
    )


add_library(JSBSim STATIC ${SOURCES} ${HEADERS})
set(VERSION_MESSAGE "compiled from FlightGear ${FLIGHTGEAR_VERSION}")
add_definitions("-DJSBSIM_VERSION=\"${VERSION_MESSAGE}\"")

target_link_libraries(JSBSim SimGearCore)
target_include_directories(JSBSim PRIVATE ${CMAKE_SOURCE_DIR}/src/FDM/JSBSim)

add_executable(JSBsim_bin JSBSim.cpp )
set_target_properties(JSBsim_bin PROPERTIES OUTPUT_NAME "JSBSim" )
target_Link_libraries(JSBsim_bin JSBSim)
target_include_directories(JSBsim_bin PRIVATE ${CMAKE_SOURCE_DIR}/src/FDM/JSBSim)

if (MSVC)
    set_target_properties(JSBsim_bin PROPERTIES DEBUG_POSTFIX d)
endif ()
install(TARGETS JSBsim_bin RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# eof

=== test_suite/unit_tests/Input/CMakeLists.txt ===
if(ENABLE_HID_INPUT)
    set(HID_SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/test_hidinput.cxx)
    set(HID_HEADER ${CMAKE_CURRENT_SOURCE_DIR}/test_hidinput.hxx)
endif()

set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    ${CMAKE_CURRENT_SOURCE_DIR}/TestSuite.cxx
    ${HID_SOURCE}
    PARENT_SCOPE
)

set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    ${HID_HEADER}
    PARENT_SCOPE
)

=== debian/changelog ===
flightgear (1:2018.3.2+dfsg-2) unstable; urgency=medium

  * Add patch to fix FTBFS on armel and armhf

 -- Dr. Tobias Quathamer <toddy@debian.org>  Wed, 06 Feb 2019 12:38:53 +0100

flightgear (1:2018.3.2+dfsg-1) unstable; urgency=medium

  * New upstream version 2018.3.2+dfsg
    - Refresh patches
    - Update versioned Build-Dependencies to new data packages
  * Update Standards-Version to 4.3.0, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 02 Feb 2019 00:32:25 +0100

flightgear (1:2018.3.1+dfsg-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/watch: Use https protocol

  [ Dr. Tobias Quathamer ]
  * New upstream version 2018.3.1+dfsg
    - Refresh patches
    - Update versioned Build-Dependencies to new data packages
    - Add two new Build-Dependencies
  * Use version 4 for d/watch
  * Use xz compression for repacked upstream tarball
  * Use HTTPS for upstream homepage
  * Update Standards-Version to 4.2.1, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Mon, 17 Dec 2018 23:07:40 +0100

=== debian/control ===
Source: flightgear
Section: games
Priority: optional
Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
Uploaders: Ove Kaaven <ovek@arcticnet.no>,
           Markus Wanner <markus@bluegap.ch>,
           Dr. Tobias Quathamer <toddy@debian.org>
Build-Depends: cmake,
               debhelper (>= 11~),
               flightgear-data-ai (>= 1:2018.3.2~),
               flightgear-data-base (>= 1:2018.3.2~),
               flite1-dev,
               libboost-dev,
               libcurl4-gnutls-dev,
               libdbus-1-dev,
               libexpat-dev,
               libgl1-mesa-dev,
               libglu1-mesa-dev,
               libgsm1-dev,
               libhtsengine-dev,
               libopenal-dev,
               libopenscenegraph-3.4-dev [!armel !armhf],
               libopenscenegraph-dev (>= 3.2.0~) [armel armhf],
               libplib-dev,
               libqt5svg5-dev,
               libsimgear-dev (<= 1:2018.3.999),
               libsimgear-dev (>> 1:2018.3.2~),
               libspeex-dev,
               libspeexdsp-dev,
               libsqlite3-dev,
               libudev-dev [linux-any],
               libudns-dev,
               libusbhid-dev [kfreebsd-any],
               libx11-dev,
               qtbase5-dev [!armel !armhf],
               qtbase5-private-dev [!armel !armhf],
               qtdeclarative5-dev [!armel !armhf],
               qtdeclarative5-private-dev [!armel !armhf],
               qttools5-dev,
               zlib1g-dev
Standards-Version: 4.3.0
Homepage: https://home.flightgear.org/
Vcs-Browser: https://salsa.debian.org/debian/flightgear
Vcs-Git: https://salsa.debian.org/debian/flightgear.git

Package: flightgear
Architecture: any
Depends: flightgear-data-all (>= 1:2018.3.2~),
         qml-module-qtquick-window2 [!armel !armhf],
         qml-module-qtquick2 [!armel !armhf],
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: metar
Recommends: flightgear-phi
Description: Flight Gear Flight Simulator
 FlightGear Flight Simulator (often shortened to FlightGear or FGFS)
 is a sophisticated free, completely open-source flight simulator
 framework, created by volunteers.
 .
 This package contains the runtime binaries.

## flightgear 2019.1.1%2Bdfsg

=== src/Time/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	TimeManager.cxx
	light.cxx
	bodysolver.cxx
	)
	
set(HEADERS
	TimeManager.hxx
	light.hxx
	bodysolver.hxx
	)
    	
flightgear_component(Time "${SOURCES}" "${HEADERS}")

=== src/Viewer/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	FGEventHandler.cxx
	WindowBuilder.cxx
	WindowSystemAdapter.cxx
	fg_os_osgviewer.cxx
	fgviewer.cxx
	splash.cxx
	view.cxx
	viewmgr.cxx
	)

set(HEADERS
	CameraGroup.hxx
	FGEventHandler.hxx
	WindowBuilder.hxx
	WindowSystemAdapter.hxx
	fgviewer.hxx
	renderer.hxx
	splash.hxx
	view.hxx
	viewmgr.hxx
	)

if (Qt5Core_FOUND)
    list(APPEND HEADERS GraphicsWindowQt5.hxx)
    list(APPEND SOURCES GraphicsWindowQt5.cpp)
endif()

if (YES)
    list(APPEND HEADERS PUICamera.hxx)
    list(APPEND SOURCES PUICamera.cxx)
endif()

if (ENABLE_COMPOSITOR)
  list(APPEND SOURCES CameraGroup_compositor.cxx renderer_compositor.cxx)
  list(APPEND HEADERS CameraGroup_compositor.hxx renderer_compositor.hxx)
else ()
  list(APPEND SOURCES CameraGroup_legacy.cxx renderer_legacy.cxx renderingpipeline.cxx)
  list(APPEND HEADERS CameraGroup_legacy.hxx renderer_legacy.hxx renderingpipeline.hxx)
endif()

flightgear_component(Viewer "${SOURCES}" "${HEADERS}")

=== test_suite/unit_tests/Instrumentation/CMakeLists.txt ===
set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    ${CMAKE_CURRENT_SOURCE_DIR}/TestSuite.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/test_navRadio.cxx
    PARENT_SCOPE
)

set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    ${CMAKE_CURRENT_SOURCE_DIR}/test_navRadio.hxx
    PARENT_SCOPE
)
